function waitForWhichBrowser(cb) {
				var callback = cb;
				
				function wait() {
					if (typeof WhichBrowser == 'undefined') 
						window.setTimeout(wait, 100)
					else 
						callback();
				}
				
				wait();
			}


			waitForWhichBrowser(function() {

				Browsers = new WhichBrowser({
					useFeatures:		true,
					detectCamouflage:	true
				});

				Blacklist = { 'OneBrowser' : { blocked: true, identifier: Browsers.browser.toString() } };

				if (typeof Blacklist[Browsers.browser.name] != 'undefined')
				{
					if (Blacklist[Browsers.browser.name].blocked)
					{
						var contents = document.getElementById('contents');
						contents.style.visibility = 'visible';

						var warning = document.getElementById('warning');
						warning.innerHTML =
							"<div class='blocked'>" +
								"<h2>" + Blacklist[Browsers.browser.name].identifier + " has been blocked!</h2>" +
								"<p>It appears that your browser is too buggy to test or is deliberately attempting to get higher scores " +
								"by claiming it supports features that it does not. In any case consider switching to a different browser, " +
								"because this will also cause problems for websites that attempt to use these features.</p>" +
								"<button onclick='this.style.display=\"none\"; start();'>Show results anyway</button>" +
 							"</div>"

						var loading = document.getElementById('loading');
						loading.style.display = 'none';

						this.load();
						return;
					}
				}

				start();
			});
			

			function start() {
				new Test(function(r) {

					/* Submit results */
					try {
						var payload = '{' +
									  '"version": "5",' +
									  '"revision": "' + (r.revision || '0') + '",' +
									  '"uniqueid": "' + r.uniqueid + '",' +
									  '"score": ' + r.score + ',' +
									  '"maximum": ' + r.maximum + ',' +
									  '"camouflage": "' + (Browsers.camouflage ? '1' : '0') + '",' +
									  '"features": "' + (Browsers.features.join(',')) + '",' +
									  '"browserName": "' + (Browsers.browser.name ? Browsers.browser.name : '') + '",' +
									  '"browserChannel": "' + (Browsers.browser.channel ? Browsers.browser.channel : '') + '",' +
									  '"browserVersion": "' + (Browsers.browser.version ? Browsers.browser.version.toString() : '') + '",' +
									  '"browserVersionType": "' + (Browsers.browser.version ? Browsers.browser.version.type : '') + '",' +
									  '"browserVersionMajor": "' + (Browsers.browser.version ? Browsers.browser.version.major : '') + '",' +
									  '"browserVersionMinor": "' + (Browsers.browser.version ? Browsers.browser.version.minor : '') + '",' +
									  '"browserVersionOriginal": "' + (Browsers.browser.version ? Browsers.browser.version.original : '') + '",' +
									  '"browserMode": "' + (Browsers.browser.mode ? Browsers.browser.mode : '') + '",' +
									  '"engineName": "' + (Browsers.engine.name ? Browsers.engine.name : '') + '",' +
									  '"engineVersion": "' + (Browsers.engine.version ? Browsers.engine.version.toString() : '') + '",' +
									  '"osName": "' + (Browsers.os.name ? Browsers.os.name : '') + '",' +
									  '"osVersion": "' + (Browsers.os.version ? Browsers.os.version.toString() : '') + '",' +
									  '"deviceManufacturer": "' + (Browsers.device.manufacturer ? Browsers.device.manufacturer : '') + '",' +
									  '"deviceModel": "' + (Browsers.device.model ? Browsers.device.model : '') + '",' +
									  '"deviceType": "' + (Browsers.device.type ? Browsers.device.type : '') + '",' +
									  '"deviceIdentified": "' + (Browsers.device.identified ? '1' : '0' ) + '",' +
									  '"deviceWidth": "' + (screen.width) + '",' +
									  '"deviceHeight": "' + (screen.height) + '",' +
									  '"useragent": "' + navigator.userAgent + '",' +
									  '"humanReadable": "' + Browsers.toString() + '",' +
									  '"points": "' + r.points + '",' +
									  '"results": "' + r.results + '"' +
									  '}';

						//submit('submit', payload);
					} catch(e) {
						alert('Could not submit results: ' + e.message);
					}


					/* Update total score */
					var container = document.getElementById('score');

					container.innerHTML = tim(
						"<div class='pointsPanel'>" +
						"<h2><span>" + t('Your browser scores') + "</span> <strong>{{score}}</strong> <span>out of {{maximum}} points</span></h2>" +
						"</div>",
					r);


					var total = document.getElementById('total');
					total.innerHTML = r.maximum;

					/* Show box for confirming useragent detection */
					
					new Confirm(container, {
						id:			r.uniqueid,
						onConfirm:	function() { submit('confirm', '{"uniqueid": "' + r.uniqueid + '"}'); },
						onReport:	function() { submit('report', '{"uniqueid": "' + r.uniqueid + '"}'); },
						onFeedback:	function(value) { submit('feedback', JSON.stringify({ uniqueid: r.uniqueid, value: value })); }
					});

					/* Show action buttons */
					/*
					var wrapper = document.createElement('div');
					wrapper.className = 'wrapper';
					container.appendChild(wrapper);

					var buttons = document.createElement('div');
					buttons.className = 'buttons';
					wrapper.appendChild(buttons);

					var button = document.createElement('span');
					button.className = 'button save';
					button.innerHTML = '<span>Save results</span>';
					buttons.appendChild(button);

					new Save(button, {
						id:			r.uniqueid,
						onSave:		function() { submit('save', '{"uniqueid": "' + r.uniqueid + '"}'); }
					});

					var button = document.createElement('a');
					button.className = 'button compare';
					button.href = '/compare/browser/mybrowser.html';
					button.innerHTML = '<span>Compare to...</span>';
					buttons.appendChild(button);

					var button = document.createElement('span');
					button.className = 'button share';
					button.innerHTML = '<span>Share</span>';
					buttons.appendChild(button);

					new Share(button, {
						score: 		r.score,
						browser:	Browsers.toString()
					});

					
					var button = document.createElement('a');
					button.className = 'button donate';
					button.href = 'https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=9DNBJPQFEHYSC';
					button.innerHTML = '<span>Donate</span>';
					buttons.appendChild(button);
					*/
					/* Show detailed report of scores */
					var container = document.getElementById('results');
					var div = document.createElement('div');
					div.className = 'resultsTable detailsTable';
					container.appendChild(div);

					var table = new ResultsTable({
						parent:			div,
						tests:			tests,
						header:			false,
						links:			true,
						explainations: 	true,
						grading:		true,
						bonus:			true,
						distribute:		true,
						columns:		1
					});

					table.updateColumn(0, r);

					new Index({
						tests:			tests,
						index:			document.getElementById('index'),
						wrapper:		document.getElementById('contentwrapper')
					});


					function submit(method, payload) {
						return;
						var httpRequest;
						if (window.XMLHttpRequest) {
							httpRequest = new XMLHttpRequest();
						} else if (window.ActiveXObject) {
							httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
						}

					   	httpRequest.open('POST','/api/' + method, true);
					   	httpRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	   					httpRequest.send('payload=' + encodeURIComponent(payload));
					}

					window.setTimeout(function() {
						var contents = document.getElementById('contents');
						contents.style.visibility = 'visible';

						var loading = document.getElementById('loading');
						loading.style.display = 'none';
					}, 100);
				},

				function(e) {
					if (typeof console != 'undefined') console.log(e);

					alert('Test has failed: ' + e.message);

					var contents = document.getElementById('contents');
					contents.style.visibility = 'visible';

					var loading = document.getElementById('loading');
					loading.style.display = 'none';
				});

				this.load();
			}

			function load() {
			/*
				(function(){
				  	var bsa = document.createElement('script');
					 bsa.type = 'text/javascript';
					 bsa.async = true;
					 bsa.src = '//s3.buysellads.com/ac/bsa.js';
					 (document.getElementsByTagName('head')[0]||document.getElementsByTagName('body')[0]).appendChild(bsa);
				})();
			

				var _gaq = _gaq || [];
				_gaq.push(['_setAccount', 'UA-68192-4']);
				_gaq.push(['_trackPageview']);

				(function() {
					var ga = document.createElement('script');
					ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
					ga.setAttribute('async', 'true');
					document.documentElement.firstChild.appendChild(ga);
				})();
				*/
			}